Index: packet-lapdm.c
===================================================================
--- packet-lapdm.c	(revision 38978)
+++ packet-lapdm.c	(working copy)
@@ -289,6 +289,7 @@
     {
             fragment_data *fd_m = NULL;
             tvbuff_t *reassembled = NULL;
+            guint32 fragment_id = 0;
             gboolean save_fragmented = pinfo->fragmented;
 
             pinfo->fragmented = m;
@@ -296,8 +297,10 @@
                take N(S) into account, but N(S) isn't always 0 for
                the first fragment!
              */
+            // (dir, timeslot, subslot) tuple used as stream identification
+            fragment_id = pinfo->circuit_id | (pinfo->p2p_dir << 8);
             fd_m = fragment_add_seq_next (payload, 0, pinfo,
-                                0, /* guint32 ID for fragments belonging together */
+                                fragment_id, /* guint32 ID for fragments belonging together */
                                 lapdm_fragment_table, /* list of message fragments */
                                 lapdm_reassembled_table, /* list of reassembled messages */
                                 /*n_s guint32 fragment sequence number */
Index: packet-gsmtap.c
===================================================================
--- packet-gsmtap.c	(revision 38978)
+++ packet-gsmtap.c	(working copy)
@@ -356,6 +356,15 @@
 		pinfo->p2p_dir = P2P_DIR_RECV;
 	}
 
+	// Save the timeslot and subslot for later stream identification
+	{ 	
+		guint8 timeslot = 0;
+		guint8 subslot = 0;
+		timeslot = tvb_get_guint8(tvb, offset + 3);
+		subslot = tvb_get_guint8(tvb, offset + 14);
+		pinfo->circuit_id = timeslot * 8 + subslot;
+	}
+
 	if (tree) {
 		guint8 channel;
 		const char *channel_str;
